<Shader Name="Error">
	<Uniforms>
		<Texture Name="Main Texture" Uniform="_MainTex"/>
	</Uniforms>
	<Passes>
		<Pass Name="Deferred">
			<Vertex>
				#version 330 core
				#define VERTEX_SHADER
				#include "HLSL"
				 
				in float3 position;
				out float4 INscreenPos;
				out float4 INPscreenPos;

				void main(){
					CalcPos(position);
					INscreenPos=CalcPos(position);
					INPscreenPos = _WorldToView_Past*_LocalToWorld_Past*float4(position, 1.0);
				}
			</Vertex>
			<Fragment><![CDATA[
				#version 330 core
				#include "HLSL"
				#line 27
				//out float4 color;
				in float4 INscreenPos;
				in float4 INPscreenPos;

				layout(location = 0) out float4 Final;
				layout(location = 1) out float2 MotionBuffer;

				void main(){
                    //Final = float4(1,0,1,1);
                    Final = float4(0,0.4,1,1)*float4(0,0.4,1,1);
                    //Final = float4(1.0,1.0,1,1);
                    //Final = float4(0.0,0.0,0,1);
	float3 screenPos = (INscreenPos.xyz/INscreenPos.w+1.0)/2.0;
	float3 PscreenPos = (INPscreenPos.xyz/INPscreenPos.w+1.0)/2.0;
	MotionBuffer = (screenPos.xy-PscreenPos.xy);
				}
			]]></Fragment>
		</Pass>
		<Pass Name="NoCast">
			<Vertex>
				#version 330 core
				#define VERTEX_SHADER
				#include "HLSL"
				 
				in float3 position;

				void main(){
					CalcPos(position);
				}
			</Vertex>
			<Fragment><![CDATA[
				#version 330 core
				#include "HLSL"
				#line 27
				layout(location = 0) out float4 color;
				layout(location = 1) out float Alp;

				void main(){
                    //color = float4(1,0,1,1);
                    color = float4(0,0.4,1,1);
                    //color = float4(1.0,1.0,1,1);
                    //color = float4(0.0,0.0,0,1);
					Alp = 1.0;
				}
			]]></Fragment>
		</Pass>
		<Pass Name="Collision">
			<Vertex>
				#version 330 core
				#define VERTEX_SHADER
				#include "HLSL"
				 
				in float3 position;

				void main(){
					CalcPos(position);
				}
			</Vertex>
			<Fragment><![CDATA[
				#version 330 core
				#include "HLSL"
				#line 27
				layout(location = 0) out float4 color;
				layout(location = 1) out float Alp;

				void main(){
					discard;
				}
			]]></Fragment>
		</Pass>
		<Pass Name="DepthPass">
			<Vertex>
				#version 330 core
				#define VERTEX_SHADER
				#include "HLSL"
				 
				in float3 position;
				out float4 INscreenPos;
				out float4 INPscreenPos;

				void main(){
					CalcPos(position);
					INscreenPos=CalcPos(position);
					INPscreenPos = _WorldToView_Past*_LocalToWorld_Past*float4(position, 1.0);
				}
			</Vertex>
			<Fragment><![CDATA[
				#version 330 core
				#include "HLSL"
				#line 27
				//out float4 color;
				in float4 INscreenPos;
				in float4 INPscreenPos;

				void main(){
				}
			]]></Fragment>
		</Pass>
		<Pass Name="CollisionRender">
			<Vertex><![CDATA[
				#version 330 core
				#define VERTEX_SHADER
				#include "HLSL"
				 
				in float3 position;
				in float3 normal;
				out float3 INVworldPos;
				uniform float Strength;



				void main(){
					float3 movpos = position;
					//if (Strength>0.5)
					//	movpos.z += sin(Time.x/2)*2.5;
					INVworldPos = (_LocalToWorld*float4(movpos, 1.0)).xyz;
					gl_Position = _LocalToWorld*float4(movpos,1.0);//2.0;
				}
			]]></Vertex>
			<Fragment><![CDATA[
				#version 430 core
				#include "HLSL"
				#include "LightFields"
				#line 601
				layout (location = 0,r8) uniform restrict image3D _RayTexImageAlp;
				
				in float3 INworldPos;
				
void main(){
	float3 voxelPos = INworldPos;
	voxelPos = (_LightFieldWorldToLocal*float4(voxelPos,1)).xyz;
	voxelPos+=0.5;
	voxelPos*=_LightFieldTexSize*2;
	
	
	imageStore(_RayTexImageAlp, ivec3(voxelPos), float4(1.0,1.0,1.0,1.0));
}
			]]></Fragment>
			<Geometry><![CDATA[
				#version 330 core

				#include "LightFields"
				layout (triangles) in;
				layout (triangle_strip, max_vertices = 3) out;
				

				in vec3 INVworldPos[];

				out vec3 INworldPos;
				uniform mat4 _WorldToView;
				uniform mat4 _LocalToWorld;
				

				float triarea(vec2 p1, vec2 p2, vec2 p3){
					return abs(((p2.x - p1.x)*(p3.y - p1.y) - (p3.x - p1.x)*(p2.y - p1.y))/2.0);
				}
				void main()
				{
					int i;
					
					float XAxisarea = triarea(gl_in[0].gl_Position.yz,gl_in[1].gl_Position.yz,gl_in[2].gl_Position.yz);
					float YAxisarea = triarea(gl_in[0].gl_Position.xz,gl_in[1].gl_Position.xz,gl_in[2].gl_Position.xz);
					float ZAxisarea = triarea(gl_in[0].gl_Position.xy,gl_in[1].gl_Position.xy,gl_in[2].gl_Position.xy);
					
					vec3 tricenter = (gl_in[0].gl_Position.xyz+gl_in[1].gl_Position.xyz+gl_in[2].gl_Position.xyz)*0.333;
					for(i = 0; i < gl_in.length(); i++){
					
						gl_Position = gl_in[i].gl_Position;
						INworldPos = INVworldPos[i];
					gl_Position = vec4((((_LightFieldWorldToLocal*vec4(gl_Position.xyz,1))).xyz*2.f).xyz,1.0);
						gl_Position.xyz = gl_Position.xyz;
					if (XAxisarea>=YAxisarea&&XAxisarea>=ZAxisarea){
						gl_Position.xyz = gl_Position.yzx;
						gl_Position.y*=(_LightFieldTexSize.z/_LightFieldTexSize.y);
					}
					if (YAxisarea>=XAxisarea&&YAxisarea>=ZAxisarea){
						gl_Position.xyz = gl_Position.xzy;
						gl_Position.y*=(_LightFieldTexSize.z/_LightFieldTexSize.y);
					}
					EmitVertex();
					}
							EndPrimitive();

				}
			]]></Geometry>
		</Pass>
	</Passes>
</Shader>
