<Shader Name="FillMotionBuffer">
	<Uniforms>
		<Texture Name="Main Texture" Uniform="_MainTex"/>
	</Uniforms>
	<Passes>
		<Pass Name="Deferred">
			<Vertex>
				#version 330 core
				#include "HLSL"
				 
				layout (location = 0) in float3 position;
				layout (location = 3) in float4 color;
				layout (location = 4) in float2 uv;
				out float4 outColor;
				out float2 inUV;
				out float3 worldPos;

				void main(){
					gl_Position = float4(vec3(position.xy,1.0), 1.0);
					worldPos = (_LocalToWorld*float4(position, 1.0)).xyz;
					outColor = color;
					inUV = uv;
				}
			</Vertex>
			<Fragment><![CDATA[
				#version 330 core
				#include "HLSL"
				#line 27

				layout(location = 0) out float2 Final;

				in float4 outColor;
				in float2 inUV;
				in float3 worldPos;

				void main(){
					float4 posA = _InvWorldToView*float4(inUV*2.0-1.0,1.0,1.0);
					posA/=posA.w;
					float4 posB = _InvWorldToView_Past*float4(inUV*2.0-1.0,1.0,1.0);
					posB/=posB.w;
					
					float4 screepos = _WorldToView*vec4(posA.xyz,1.0);
					screepos.xyz/=screepos.w;
					float4 screepos2 = _WorldToView*vec4(posB.xyz,1.0);
					screepos2.xyz/=screepos2.w;
					
					Final.xy = (screepos2.xy-screepos.xy)*0.5;
				}
			]]></Fragment>
		</Pass>
	</Passes>
</Shader>