<Shader Name="MotionBlur">
	<Uniforms>
		<Texture Name="Main Texture" Uniform="_MainTex"/>
	</Uniforms>
	<Passes>
		<Pass Name="Deferred">
			<Vertex>
				#version 330 core
				#include "HLSL"
				 
				layout (location = 0) in float3 position;
				layout (location = 3) in float4 color;
				layout (location = 4) in float2 uv;
				out float2 inUV;
				out float3 worldPos;

				void main(){
					gl_Position = float4(position, 1.0);
					worldPos = (_LocalToWorld*float4(position, 1.0)).xyz;
					inUV = uv;
				}
			</Vertex>
			<Fragment><![CDATA[
				#version 430 core
				#include "HLSL"

				#line 27
				out float4 color;
				in float2 inUV;
				in float3 worldPos;
				
				uniform sampler2DMS Normals;
				
				uniform sampler2D BufferDepth;
				
				uniform sampler2D MotionVectors;
				uniform sampler2D TempLightmapStopgap;
				uniform sampler2D _MainTex;
				uniform sampler2D BufferFinalLastFrame;
				
				const[PreCompile]uniform float _VisualizeVoxels;
				
				uniform float3 RayTopLeft;
				uniform float3 RayBottomLeft;
				uniform float3 RayTopRight;
				uniform float3 RayBottomRight;
				uniform float3 RayCenter;
				
				uniform sampler3D _LightFieldDistanceMips;
				void main(){
					#line 69
					//Voxels Visualization
					/*if (_VisualizeVoxels==1.0){				
						float3 ray = lerp(lerp(RayTopLeft,RayBottomLeft,1.0-inUV.y),lerp(RayTopRight,RayBottomRight,1.0-inUV.y),inUV.x);
						ray = ray/length(RayCenter);
						ray = normalize(ray);

						float4 posA = _InvWorldToView*float4(inUV*2.0-1.0,textureLod(BufferDepth,inUV,0).r*2.0-1.0,1.0);
						posA/=posA.w;
						ray = normalize(posA.xyz-_CameraPos.xyz);
						color.a = 0;
						float stepSize = 0.5*5.0;
						float3 rayOrigin = (_LightFieldWorldToLocal*float4(_CameraPos+vec3(-6.8,17,8.1),1)).xyz+0.5;
						float3 hitPos;
						color.rgb = raycast(0,_CameraPos+normalize(ray)*0.2,normalize(ray),false,64,hitPos).rgb;
						color = pow(color,vec4(1.0/2.2));
						rayOrigin = (_LightFieldWorldToLocal*float4(hitPos,1)).xyz+0.5;	
						return;
					}*/
					float2 MotionVector = DecodeMotionVectors(textureLod(MotionVectors,inUV,0).xy);
					float4 oResult = tex2D(_MainTex,inUV);
					float2 UVs = inUV;
					UVs=(UVs-0.5)*2.0;
					//UVs*=1.0/(1.0+length(UVs));//Wow
					//UVs*=1.0/(1.0+length(UVs)*(sin(Time.x)*0.5+0.5));//Wow
					//UVs*=(0.95+0.05*length(UVs));
					UVs=UVs*0.5+0.5;
						float2 velocity = MotionVector.xy*1;
						float nSamples = 10;
						oResult = textureLod(_MainTex, UVs,0);
						for (float i = 1; i < nSamples; ++i) {
							float2 offset = velocity * (i / (nSamples - 1)-0.5);
							float3 s = textureLod(_MainTex, UVs + offset,0).xyz;
							oResult.xyz += s;
						}
						oResult.xyz /= nSamples;
					
					color = (oResult);
					color.a = 1;
					
					//Vignette
					float len = length(UVs-0.5);
					float RADIUS = 0.68;
					float SOFTNESS = 0.6;
					float vignette = smoothstep(RADIUS, RADIUS-SOFTNESS, len);
					color*=vignette;
					
					//Filmic response...
					color.xyz = vec3(1.0)-exp(-color.xyz);
					
					//Gamma Correction
					color.xyz = pow(color.xyz,float3(1.0/2.2));
					return;
				}
			]]></Fragment>
		</Pass>
	</Passes>
</Shader>