<Shader Name="TemporalSupersample">
	<Uniforms>
		<Texture Name="Main Texture" Uniform="_MainTex"/>
	</Uniforms>
	<Passes>
		<Pass Name="Deferred">
			<Vertex>
				#version 330 core
				#include "HLSL"
				 
				layout (location = 0) in float3 position;
				layout (location = 4) in float2 uv;
				out float2 inUV;
				void main(){
					gl_Position = float4(position, 1.0);
					inUV = uv;
				}
			</Vertex>
			<Fragment><![CDATA[
				#version 330 core
				#include "HLSL"
				#line 22

				layout(location = 0) out float4 color;
				//layout(location = 1) out float newness;//Previously I keep track of samples gathered so they average linearly rather than exponentially
				in float2 inUV;
				
				uniform sampler2D _MainTex;
				uniform sampler2D BufferFinalLastFrame;
				
				uniform sampler2D MotionVectors;
				
				
				uniform float TemporalSSExponent;
				void main(){
					
					float2 MotionVector = tex2D(MotionVectors,inUV).xy;
					float2 lastUV = inUV-MotionVector.xy;
					
					
					float4 thisFrame = textureLod(_MainTex,inUV,0);
					float4 lastFrame = textureLod(BufferFinalLastFrame,lastUV,0);
					
					color = thisFrame;
					//Check if previous frame is outside the viewport, if so don't blend
					if (dot(saturate(lastUV)-lastUV,vec2(1.0))==0){
						color = lerp(lastFrame,thisFrame,TemporalSSExponent);
					}
					
					//Somehow NANs can creep in, fix them.
					if (isnan(color.r))color.r = 0.0;
					if (isnan(color.g))color.g = 0.0;
					if (isnan(color.b))color.b = 0.0;
				}
			]]></Fragment>
		</Pass>
	</Passes>
</Shader>