<Shader Name="GUIGeneric">
	<Uniforms>
		<Texture Name="Main Texture" Uniform="_MainTex"/>
		<Vector4 Name="_ButtonCoords" Uniform="_ButtonCoords"/>
		<Vector4 Name="GlowColor" Uniform="GlowColor"/>
		<Vector4 Name="TopColor" Uniform="TopColor"/>
		<Vector4 Name="BottomColor" Uniform="BottomColor"/>
		<Vector4 Name="BorderRadius" Uniform="BorderRadius"/>
		<Vector4 Name="OutlineColor" Uniform="OutlineColor"/>
		<Float Name="OutlineThickness" Uniform="OutlineThickness"/>
	</Uniforms>
	<Passes>
		<Pass Name="Deferred">
			<Vertex>
				#version 330 core
				#define VERTEX_SHADER
				#include "HLSL"
				 
				in float3 position;
				in float2 uv;
				out float2 inUV;
				out float3 inPos;

				uniform float4 _ButtonCoords;
				uniform float4 GlowColor;
				void main(){
					float2 normuv = position.xy*0.5+0.5;
					float3 pos = (_LocalToWorld*float4(position,1)).xyz;
					if (dot(float3(1,1,1),GlowColor.rgb)>0.01){
						pos.x = lerp(pos.x-170,pos.x+170,normuv.x);
						pos.y = lerp(pos.y-170,pos.y+170,normuv.y);
						inUV.x = lerp(_ButtonCoords.x-170,_ButtonCoords.z+170,normuv.x);
						inUV.y = lerp(_ButtonCoords.y-170,_ButtonCoords.w+170,normuv.y);	
					}else{
						inUV.x = lerp(_ButtonCoords.x,_ButtonCoords.z,normuv.x);
						inUV.y = lerp(_ButtonCoords.y,_ButtonCoords.w,normuv.y);	
					}
					CalcPosFromWorld(pos);
				}
			</Vertex>
			<Fragment><![CDATA[
				#version 330 core
				#include "HLSL"
				#include "GUI"
				#line 27
				out float4 color;
				in float2 inUV;
				in float3 inPos;




				uniform float4 GlowColor;
				uniform float4 TopColor;
				uniform float4 BottomColor;
				uniform float4 BorderRadius;
				uniform float4 OutlineColor;
				uniform float OutlineThickness;

				uniform float4 _ButtonCoords;
				void main(){
					float roundness = BorderRadius.x;
                    color = float4(1,0,1,1);
					
					float2 coord = inUV;
					float2 tl = _ButtonCoords.xy;
					float2 br = _ButtonCoords.zw;

					
				antialiasing = 0.5;
					float glow = distanceRoundedRectangle(tl+aacalc(coord),br-aacalc(coord),roundness,coord)*0.1;

					float attenglow = 1.0/(max(sqrt(glow)+0,0));
					if(glow<=0.0000001)
						attenglow = 0;
					color.rgb = GlowColor.rgb*attenglow;
					color.rgb*=1.0-smoothstep(0,170,glow*10);
					antialiasing = 1;
										color.a = saturate(insideRoundedRectangle(tl,br,roundness,coord));
					color.rgba = lerp(color.rgba,lerp(TopColor.rgba*TopColor.a,BottomColor.rgba*BottomColor.a,smoothstep(tl.y,br.y,coord.y)),color.a);
					color*=0.5;
					antialiasing = 1;
	if(OutlineThickness>0)		
	color.rgba = lerp(color.rgba,OutlineColor,(insideRoundedRectangle(tl,br,roundness,coord))*(1-insideRoundedRectangle(tl-vec2(-OutlineThickness,-OutlineThickness)*fwidth(coord),br+vec2(-OutlineThickness,-OutlineThickness)*fwidth(coord),roundness,coord)));
				}
			]]></Fragment>
		</Pass>
	</Passes>
</Shader>
