<Shader Name="TextBasi">
	<Uniforms>
		<Texture Name="Main Texture" Uniform="_MainTex"/>
	</Uniforms>
	<Passes>
		<Pass Name="Deferred">
			<Vertex>
				#version 330 core
				#define VERTEX_SHADER
				#include "HLSL"
				 
				in float3 position;
				in float2 uv;
				out float2 inUV;

				void main(){
					float3 pos = (_LocalToWorld*float4(position,1)).xyz;
					CalcPosFromWorld(pos);
					inUV = uv;//position.xy*float2(0.5,0.5)+float2(0.5,0.5);
				}
			</Vertex>
			<Fragment><![CDATA[
				#version 330 core
				#include "HLSL"
				#line 27
				out float4 color;
				in float2 inUV;

				uniform sampler2D _MainTex;

				void main(){
                    float2 uv = inUV;
					float text = (tex2D(_MainTex,uv).r);
					text = pow(text,2.2);
					color = float4(1,1,1,1);
					float antialias = fwidth(uv.x)*70;
					float boldness = -0.4;
					color *= 1.0-smoothstep(0.75-antialias+boldness,0.75+antialias+boldness, text);
				}
			]]></Fragment>
		</Pass>
	</Passes>
</Shader>
